<?php
class CuentaImpuesto
{
    public $cuenta;
    public $impuesto;
    public $monto;
    public $saldo;
    public $observaciones;

    function __construct()
    {
        !empty($this->monto) && $this->monto = '$' . number_format($this->monto, 2, '.', ',');
        !empty($this->saldo) && $this->saldo = '$' . number_format($this->saldo, 2, '.', ',');
    }

    public static function obtenerCXPPendientes(): object
    {
        $db = obtenerConexion();

        $query = "select impuestos.codempresa,
            impuestos.ctaimpuesto cuenta,
            impuestos.observaciones,
            tipos.nomtipoimpuesto impuesto,
            detalles.monto,
            detalles.saldo,
            detalles.observaciones observaciones_detalles
        from [" . DB_NET . "].dbo.bnc_ctaimpuestos impuestos
        inner join [" . DB_NET . "].dbo.bnc_ctaimpuestos_det detalles on impuestos.codempresa = detalles.codempresa and impuestos.ctaimpuesto = detalles.ctaimpuesto
        inner join [" . DB_NET . "].dbo.bnc_tipo_impuesto tipos on detalles.codtipoimpuesto = tipos.codtipoimpuesto and detalles.codempresa = tipos.codempresa
        WHERE detalles.saldo > 0;";
        $stmt = $db->prepare($query, [PDO::ATTR_CURSOR => PDO::CURSOR_SCROLL, PDO::SQLSRV_ATTR_CURSOR_SCROLL_TYPE => PDO::SQLSRV_CURSOR_BUFFERED]);

        try {
            $stmt->execute();

            $datos = $stmt->fetchAll(PDO::FETCH_CLASS, __CLASS__);

            return (object)[
                'status' => 200,
                'data' => $datos
            ];
        } catch (PDOException $e) {
            return (object)[
                'status' => 500,
                'message' => $e->getMessage()
            ];
        }
    }
}
